(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('dc-scc'), require('dc-eas-api'), require('dc-dds-api')) :
    typeof define === 'function' && define.amd ? define('dc-ras-api', ['exports', '@angular/core', 'dc-scc', 'dc-eas-api', 'dc-dds-api'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['dc-ras-api'] = {}, global.ng.core, global['dc-scc'], global['dc-eas-api'], global['dc-dds-api']));
}(this, (function (exports, i0, i1, i2, dcDdsApi) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var BaseFactory = /** @class */ (function (_super) {
        __extends(BaseFactory, _super);
        function BaseFactory() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        BaseFactory.prototype.newRequest = function () {
            return __awaiter(this, void 0, void 0, function () {
                var reqObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            return [2 /*return*/, reqObj];
                    }
                });
            });
        };
        BaseFactory.prototype.clearCache = function (obj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    if (typeof this._s[obj.getGuid()] != "undefined") {
                        delete this._s[obj.getGuid()];
                    }
                    return [2 /*return*/, this];
                });
            });
        };
        BaseFactory.prototype.getByGuids = function (guids, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var utilObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            utilObj = this.getService().getDcScc().getUtilities().getFactories().getAsyncGuids();
                            return [4 /*yield*/, utilObj.getByGuids(guids, this, "getByGuid", cbObj, cbMethod)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        return BaseFactory;
    }(i1.DcSccBaseFactory));

    var Connection = /** @class */ (function (_super) {
        __extends(Connection, _super);
        function Connection() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._wsHost = "dc-wss-nlb.datacamo.net";
            _this._wsPort = 28103;
            _this._wsSsl = true;
            _this._isReconn = false;
            _this._wrkObj = null;
            return _this;
        }
        Connection.prototype.setConfig = function (host, port, ssl) {
            if (ssl === void 0) { ssl = true; }
            this._wsHost = host;
            this._wsPort = port;
            this._wsSsl = ssl;
            return this;
        };
        Connection.prototype.getClient = function () {
            return __awaiter(this, void 0, void 0, function () {
                var wrkObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getWorker()];
                        case 1:
                            wrkObj = _a.sent();
                            return [2 /*return*/, wrkObj.getClient()];
                    }
                });
            });
        };
        Connection.prototype.getWorker = function () {
            return __awaiter(this, void 0, void 0, function () {
                var cObj, reqObj, salt, reqObj, hash, ephKey, sessObj, errObj_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this._wrkObj === null)) return [3 /*break*/, 9];
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 8, , 9]);
                            this._wrkObj = this.getService().getDcScc().getWorkers().getV3(this._wsHost, this._wsPort, this._wsSsl);
                            return [4 /*yield*/, this._wrkObj.initialize()];
                        case 2:
                            _a.sent();
                            cObj = this._wrkObj.getClient();
                            reqObj = cObj.newMessage();
                            reqObj.setL1("Authentication").setL2("Get").setL3("Salt");
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            salt = _a.sent();
                            reqObj = cObj.newMessage();
                            reqObj.setL1("Authentication").setL2("Validate").setL3("ByEAS").setL4("EphemeralKey");
                            return [4 /*yield*/, this.getMtm().get("utilities").getHashing().getSHA().get256("RAS--" + salt)];
                        case 4:
                            hash = _a.sent();
                            return [4 /*yield*/, this.getMtm().get("DcEasApi").getEphemeralKeys().newReadUserPublic()];
                        case 5:
                            ephKey = _a.sent();
                            return [4 /*yield*/, ephKey.signRequest(reqObj, hash)];
                        case 6:
                            _a.sent();
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 7:
                            sessObj = _a.sent();
                            if (typeof sessObj["session-id"] != "undefined"
                                && typeof sessObj["session-key"] != "undefined") {
                                cObj.setSession(sessObj["session-id"], sessObj["session-key"]);
                                this._wrkObj.setTermCb(this, "reconnect");
                            }
                            else {
                                throw this.getMtm().newException("Server authentication returned an invalid session");
                            }
                            return [3 /*break*/, 9];
                        case 8:
                            errObj_1 = _a.sent();
                            this._wrkObj = null;
                            throw errObj_1;
                        case 9: return [2 /*return*/, this._wrkObj];
                    }
                });
            });
        };
        Connection.prototype.reconnect = function (wrkObj) {
            return __awaiter(this, void 0, void 0, function () {
                var errObj_2, errObj_3;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this._isReconn === false)) return [3 /*break*/, 7];
                            this._isReconn = true;
                            this.logInfo("RAS Reconnecting");
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 6, , 7]);
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 4, , 5]);
                            this._wrkObj = null;
                            return [4 /*yield*/, this.getWorker()];
                        case 3:
                            _a.sent();
                            this._isReconn = false;
                            this.logInfo("RAS Reconnect success");
                            return [3 /*break*/, 5];
                        case 4:
                            errObj_2 = _a.sent();
                            throw this.getService().getMtm().newException("RAS Reconnect failed");
                        case 5: return [3 /*break*/, 7];
                        case 6:
                            errObj_3 = _a.sent();
                            this._isReconn = false;
                            this.callException(errObj_3);
                            return [3 /*break*/, 7];
                        case 7: return [2 /*return*/];
                    }
                });
            });
        };
        return Connection;
    }(BaseFactory));

    var Base = /** @class */ (function (_super) {
        __extends(Base, _super);
        function Base() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._guid = null;
            return _this;
        }
        Base.prototype.baseConstruct = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                var ddsObj, storeObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            this.setExceptionCb(this.getService().getLogging(), "exception");
                            this._guid = apiObj.guid;
                            if (!(typeof apiObj["ddsId"] != "undefined")) return [3 /*break*/, 4];
                            return [4 /*yield*/, this.getService().getDdsClient()];
                        case 1:
                            ddsObj = _a.sent();
                            this.setConfig(ddsObj, apiObj.ddsId, apiObj.ddsAuth);
                            return [4 /*yield*/, this.pubStore()];
                        case 2:
                            storeObj = _a.sent();
                            return [4 /*yield*/, storeObj.initialize()];
                        case 3:
                            _a.sent();
                            _a.label = 4;
                        case 4: return [2 /*return*/];
                    }
                });
            });
        };
        Base.prototype.getGuid = function () {
            return this._guid;
        };
        Base.prototype.newRequest = function () {
            return __awaiter(this, void 0, void 0, function () {
                var reqObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            return [2 /*return*/, reqObj];
                    }
                });
            });
        };
        return Base;
    }(dcDdsApi.DcDdsObjectModelV1));

    var Network = /** @class */ (function (_super) {
        __extends(Network, _super);
        function Network() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Network.prototype.construct = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.baseConstruct(apiObj)];
                        case 1:
                            _a.sent();
                            this.setInit();
                            return [2 /*return*/, this];
                    }
                });
            });
        };
        Network.prototype.getNs = function () {
            return this.getPubKey("ns", true);
        };
        Network.prototype.setNs = function (permObj) {
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, waitUp, errObj_1, errObj_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 7, , 8]);
                            if (!(permObj.getNs() !== this.getNs())) return [3 /*break*/, 6];
                            return [4 /*yield*/, this.getService().newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("Networks").setL2("Set").setL3("Namespace");
                            reqObj.addReq("guid", this.getGuid());
                            reqObj.addReq("namespace", permObj.getNs());
                            waitUp = this.getPubUpdateWait();
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            _a.sent();
                            return [4 /*yield*/, waitUp];
                        case 4:
                            _a.sent();
                            return [3 /*break*/, 6];
                        case 5:
                            errObj_1 = _a.sent();
                            this.pubUpdateClear(waitUp);
                            throw errObj_1;
                        case 6: return [2 /*return*/, this];
                        case 7:
                            errObj_2 = _a.sent();
                            this.callException(errObj_2);
                            throw errObj_2;
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        Network.prototype.getDisplayName = function () {
            return this.getPubKey("displayName", true);
        };
        Network.prototype.setDisplayName = function (name) {
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, waitUp, errObj_3;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.getDisplayName() !== name)) return [3 /*break*/, 6];
                            return [4 /*yield*/, this.getService().newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("Networks").setL2("Set").setL3("DisplayName");
                            reqObj.addReq("guid", this.getGuid());
                            reqObj.addReq("name", name);
                            waitUp = this.getPubUpdateWait();
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            _a.sent();
                            return [4 /*yield*/, waitUp];
                        case 4:
                            _a.sent();
                            return [3 /*break*/, 6];
                        case 5:
                            errObj_3 = _a.sent();
                            this.pubUpdateClear(waitUp);
                            throw errObj_3;
                        case 6: return [2 /*return*/, this];
                    }
                });
            });
        };
        Network.prototype.getWiredRejectVlan = function () {
            return this.getPubKey("wiredRejectVlan", true);
        };
        Network.prototype.setWiredRejectVlan = function (id) {
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, waitUp, errObj_4;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.getWiredRejectVlan() !== id)) return [3 /*break*/, 6];
                            return [4 /*yield*/, this.getService().newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("Networks").setL2("Set").setL3("WiredRejectVlan");
                            reqObj.addReq("guid", this.getGuid());
                            reqObj.addReq("id", id);
                            waitUp = this.getPubUpdateWait();
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            _a.sent();
                            return [4 /*yield*/, waitUp];
                        case 4:
                            _a.sent();
                            return [3 /*break*/, 6];
                        case 5:
                            errObj_4 = _a.sent();
                            this.pubUpdateClear(waitUp);
                            throw errObj_4;
                        case 6: return [2 /*return*/, this];
                    }
                });
            });
        };
        Network.prototype.getWirelessRejectVlan = function () {
            return this.getPubKey("wlanRejectVlan", true);
        };
        Network.prototype.setWirelessRejectVlan = function (id) {
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, waitUp, errObj_5;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.getWirelessRejectVlan() !== id)) return [3 /*break*/, 6];
                            return [4 /*yield*/, this.getService().newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("Networks").setL2("Set").setL3("WirelessRejectVlan");
                            reqObj.addReq("guid", this.getGuid());
                            reqObj.addReq("id", id);
                            waitUp = this.getPubUpdateWait();
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            _a.sent();
                            return [4 /*yield*/, waitUp];
                        case 4:
                            _a.sent();
                            return [3 /*break*/, 6];
                        case 5:
                            errObj_5 = _a.sent();
                            this.pubUpdateClear(waitUp);
                            throw errObj_5;
                        case 6: return [2 /*return*/, this];
                    }
                });
            });
        };
        Network.prototype.getNasDevices = function (cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().getNasDevices().getByNetwork(this, cbObj, cbMethod)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        Network.prototype.getUserMaps = function (cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().getUserNetMaps().getByNetwork(this, cbObj, cbMethod)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        Network.prototype.clearUserMap = function (mapObj) {
            return __awaiter(this, void 0, void 0, function () {
                var netObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, mapObj.getNetwork()];
                        case 1:
                            netObj = _a.sent();
                            if (netObj.getGuid() !== this.getGuid()) {
                                throw this.getMtm().newException("Cannot delete, user map is not mapped");
                            }
                            return [2 /*return*/, this];
                    }
                });
            });
        };
        Network.prototype.getCreated = function () {
            return this.getPubKey("created", true);
        };
        Network.prototype.terminate = function (throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            this.setTerm();
            this.getService().getNetworks().clearCache(this);
        };
        return Network;
    }(Base));

    var Networks = /** @class */ (function (_super) {
        __extends(Networks, _super);
        function Networks() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Networks.prototype.newObj = function () {
            var rObj = new Network();
            rObj.setService(this.getService());
            return rObj;
        };
        Networks.prototype.getByApiObj = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (typeof this._s[apiObj.guid] === "undefined") {
                                this._s[apiObj.guid] = this.newObj();
                                this._s[apiObj.guid].construct(apiObj);
                            }
                            return [4 /*yield*/, this._s[apiObj.guid].waitInit()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/, this._s[apiObj.guid]];
                    }
                });
            });
        };
        Networks.prototype.getBySession = function (cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, guids, errObj_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("Networks").setL2("Get").setL3("BySession");
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            guids = _a.sent();
                            return [4 /*yield*/, this.getByGuids(guids, cbObj, cbMethod)];
                        case 4: return [2 /*return*/, _a.sent()];
                        case 5:
                            errObj_1 = _a.sent();
                            this.callException(errObj_1);
                            throw errObj_1;
                        case 6: return [2 /*return*/];
                    }
                });
            });
        };
        Networks.prototype.getByGuid = function (guid, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, apiObj, rObj, errObj_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(typeof this._s[guid] !== "undefined")) return [3 /*break*/, 2];
                            return [4 /*yield*/, this._s[guid].waitInit()];
                        case 1:
                            _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](this._s[guid]);
                            }
                            return [2 /*return*/, this._s[guid]];
                        case 2: return [4 /*yield*/, this.newRequest()];
                        case 3:
                            reqObj = _a.sent();
                            reqObj.setL1("Networks").setL2("Get").setL3("ByGuid");
                            reqObj.addReq("guid", guid);
                            _a.label = 4;
                        case 4:
                            _a.trys.push([4, 7, , 8]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 5:
                            apiObj = _a.sent();
                            return [4 /*yield*/, this.getByApiObj(apiObj)];
                        case 6:
                            rObj = _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](rObj);
                            }
                            return [2 /*return*/, rObj];
                        case 7:
                            errObj_2 = _a.sent();
                            throw errObj_2;
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        return Networks;
    }(BaseFactory));

    var NasDevice = /** @class */ (function (_super) {
        __extends(NasDevice, _super);
        function NasDevice() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        NasDevice.prototype.construct = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.baseConstruct(apiObj)];
                        case 1:
                            _a.sent();
                            this.setInit();
                            return [2 /*return*/, this];
                    }
                });
            });
        };
        NasDevice.prototype.getNs = function () {
            return this.getPubKey("ns", true);
        };
        NasDevice.prototype.setNs = function (permObj) {
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, waitUp, errObj_1, errObj_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 7, , 8]);
                            if (!(permObj.getNs() !== this.getNs())) return [3 /*break*/, 6];
                            return [4 /*yield*/, this.getService().newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("NasDevices").setL2("Set").setL3("Namespace");
                            reqObj.addReq("guid", this.getGuid());
                            reqObj.addReq("usm-ns-guid", permObj.getGuid());
                            waitUp = this.getPubUpdateWait();
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            _a.sent();
                            return [4 /*yield*/, waitUp];
                        case 4:
                            _a.sent();
                            return [3 /*break*/, 6];
                        case 5:
                            errObj_1 = _a.sent();
                            this.pubUpdateClear(waitUp);
                            throw errObj_1;
                        case 6: return [2 /*return*/, this];
                        case 7:
                            errObj_2 = _a.sent();
                            this.callException(errObj_2);
                            throw errObj_2;
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        NasDevice.prototype.getDisplayName = function () {
            return this.getPubKey("displayName", true);
        };
        NasDevice.prototype.setDisplayName = function (name) {
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, waitUp, errObj_3, errObj_4;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 7, , 8]);
                            if (!(name != this.getDisplayName())) return [3 /*break*/, 6];
                            return [4 /*yield*/, this.getService().newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("NasDevices").setL2("Set").setL3("DisplayName");
                            reqObj.addReq("guid", this.getGuid());
                            reqObj.addReq("name", name);
                            waitUp = this.getPubUpdateWait();
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            _a.sent();
                            return [4 /*yield*/, waitUp];
                        case 4:
                            _a.sent();
                            return [3 /*break*/, 6];
                        case 5:
                            errObj_3 = _a.sent();
                            this.pubUpdateClear(waitUp);
                            throw errObj_3;
                        case 6: return [2 /*return*/, this];
                        case 7:
                            errObj_4 = _a.sent();
                            this.callException(errObj_4);
                            throw errObj_4;
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        NasDevice.prototype.getNetwork = function (cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().getNetworks().getByGuid(this.getPubKey("networkGuid", true), cbObj, cbMethod)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        NasDevice.prototype.setNetwork = function (netObj) {
            return __awaiter(this, void 0, void 0, function () {
                var curObj, reqObj, waitUp, errObj_5, errObj_6;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 8, , 9]);
                            return [4 /*yield*/, this.getNetwork()];
                        case 1:
                            curObj = _a.sent();
                            if (!(netObj.getGuid() !== curObj.getGuid())) return [3 /*break*/, 7];
                            return [4 /*yield*/, this.getService().newRequest()];
                        case 2:
                            reqObj = _a.sent();
                            reqObj.setL1("NasDevices").setL2("Set").setL3("Network");
                            reqObj.addReq("guid", this.getGuid());
                            reqObj.addReq("net-guid", netObj.getGuid());
                            waitUp = this.getPubUpdateWait();
                            _a.label = 3;
                        case 3:
                            _a.trys.push([3, 6, , 7]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 4:
                            _a.sent();
                            return [4 /*yield*/, waitUp];
                        case 5:
                            _a.sent();
                            return [3 /*break*/, 7];
                        case 6:
                            errObj_5 = _a.sent();
                            this.pubUpdateClear(waitUp);
                            throw errObj_5;
                        case 7: return [2 /*return*/, this];
                        case 8:
                            errObj_6 = _a.sent();
                            this.callException(errObj_6);
                            throw errObj_6;
                        case 9: return [2 /*return*/];
                    }
                });
            });
        };
        NasDevice.prototype.getCreated = function () {
            return this.getPubKey("created", true);
        };
        NasDevice.prototype.terminate = function (throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            this.setTerm();
            this.getService().getNasDevices().clearCache(this);
        };
        return NasDevice;
    }(Base));

    var NasDevices = /** @class */ (function (_super) {
        __extends(NasDevices, _super);
        function NasDevices() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        NasDevices.prototype.newObj = function () {
            var rObj = new NasDevice();
            rObj.setService(this.getService());
            return rObj;
        };
        NasDevices.prototype.getByApiObj = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (typeof this._s[apiObj.guid] === "undefined") {
                                this._s[apiObj.guid] = this.newObj();
                                this._s[apiObj.guid].construct(apiObj);
                            }
                            return [4 /*yield*/, this._s[apiObj.guid].waitInit()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/, this._s[apiObj.guid]];
                    }
                });
            });
        };
        NasDevices.prototype.getByNetwork = function (netObj, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, guids, errObj_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("NasDevices").setL2("Get").setL3("ByNetwork");
                            reqObj.addReq("guid", netObj.getGuid());
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            guids = _a.sent();
                            return [4 /*yield*/, this.getByGuids(guids, cbObj, cbMethod)];
                        case 4: return [2 /*return*/, _a.sent()];
                        case 5:
                            errObj_1 = _a.sent();
                            this.callException(errObj_1);
                            throw errObj_1;
                        case 6: return [2 /*return*/];
                    }
                });
            });
        };
        NasDevices.prototype.getByGuid = function (guid, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, apiObj, rObj, errObj_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(typeof this._s[guid] !== "undefined")) return [3 /*break*/, 2];
                            return [4 /*yield*/, this._s[guid].waitInit()];
                        case 1:
                            _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](this._s[guid]);
                            }
                            return [2 /*return*/, this._s[guid]];
                        case 2: return [4 /*yield*/, this.newRequest()];
                        case 3:
                            reqObj = _a.sent();
                            reqObj.setL1("NasDevices").setL2("Get").setL3("ByGuid");
                            reqObj.addReq("guid", guid);
                            _a.label = 4;
                        case 4:
                            _a.trys.push([4, 7, , 8]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 5:
                            apiObj = _a.sent();
                            return [4 /*yield*/, this.getByApiObj(apiObj)];
                        case 6:
                            rObj = _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](rObj);
                            }
                            return [2 /*return*/, rObj];
                        case 7:
                            errObj_2 = _a.sent();
                            throw errObj_2;
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        return NasDevices;
    }(BaseFactory));

    var User = /** @class */ (function (_super) {
        __extends(User, _super);
        function User() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        User.prototype.construct = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.baseConstruct(apiObj)];
                        case 1:
                            _a.sent();
                            this.setInit();
                            return [2 /*return*/, this];
                    }
                });
            });
        };
        User.prototype.getUsername = function () {
            return this.getPubKey("username", true);
        };
        User.prototype.setUsername = function (val) {
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, waitUp, errObj_1, errObj_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 7, , 8]);
                            if (!(val != this.getUsername())) return [3 /*break*/, 6];
                            return [4 /*yield*/, this.getService().newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("Users").setL2("Set").setL3("Username");
                            reqObj.addReq("guid", this.getGuid());
                            reqObj.addReq("username", val);
                            waitUp = this.getPubUpdateWait();
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            _a.sent();
                            return [4 /*yield*/, waitUp];
                        case 4:
                            _a.sent();
                            return [3 /*break*/, 6];
                        case 5:
                            errObj_1 = _a.sent();
                            this.pubUpdateClear(waitUp);
                            throw errObj_1;
                        case 6: return [2 /*return*/, this];
                        case 7:
                            errObj_2 = _a.sent();
                            this.callException(errObj_2);
                            throw errObj_2;
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        User.prototype.setPassword = function (val) {
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, errObj_3;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 3, , 4]);
                            return [4 /*yield*/, this.getService().newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("Users").setL2("Set").setL3("Password");
                            reqObj.addReq("guid", this.getGuid());
                            reqObj.addReq("password", val);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 2:
                            _a.sent();
                            return [2 /*return*/, this];
                        case 3:
                            errObj_3 = _a.sent();
                            this.callException(errObj_3);
                            throw errObj_3;
                        case 4: return [2 /*return*/];
                    }
                });
            });
        };
        User.prototype.getNs = function () {
            return this.getPubKey("ns", true);
        };
        User.prototype.setNs = function (permObj) {
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, waitUp, errObj_4, errObj_5;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 7, , 8]);
                            if (!(permObj.getNs() !== this.getNs())) return [3 /*break*/, 6];
                            return [4 /*yield*/, this.getService().newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("Users").setL2("Set").setL3("Namespace");
                            reqObj.addReq("guid", this.getGuid());
                            reqObj.addReq("namespace", permObj.getNs());
                            waitUp = this.getPubUpdateWait();
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            _a.sent();
                            return [4 /*yield*/, waitUp];
                        case 4:
                            _a.sent();
                            return [3 /*break*/, 6];
                        case 5:
                            errObj_4 = _a.sent();
                            this.pubUpdateClear(waitUp);
                            throw errObj_4;
                        case 6: return [2 /*return*/, this];
                        case 7:
                            errObj_5 = _a.sent();
                            this.callException(errObj_5);
                            throw errObj_5;
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        User.prototype.getNote = function () {
            return this.getPubKey("note", true);
        };
        User.prototype.setNote = function (val) {
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, waitUp, errObj_6, errObj_7;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 7, , 8]);
                            if (!(val != this.getNote())) return [3 /*break*/, 6];
                            return [4 /*yield*/, this.getService().newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("Users").setL2("Set").setL3("Note");
                            reqObj.addReq("guid", this.getGuid());
                            reqObj.addReq("note", val);
                            waitUp = this.getPubUpdateWait();
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            _a.sent();
                            return [4 /*yield*/, waitUp];
                        case 4:
                            _a.sent();
                            return [3 /*break*/, 6];
                        case 5:
                            errObj_6 = _a.sent();
                            this.pubUpdateClear(waitUp);
                            throw errObj_6;
                        case 6: return [2 /*return*/, this];
                        case 7:
                            errObj_7 = _a.sent();
                            this.callException(errObj_7);
                            throw errObj_7;
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        User.prototype.getNetworkMaps = function (cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().getUserNetMaps().getByUser(this, cbObj, cbMethod)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        User.prototype.clearNetworkMap = function (mapObj) {
            return __awaiter(this, void 0, void 0, function () {
                var userObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, mapObj.getUser()];
                        case 1:
                            userObj = _a.sent();
                            if (userObj.getGuid() !== this.getGuid()) {
                                throw this.getMtm().newException("Cannot delete, user map is not mapped");
                            }
                            return [2 /*return*/, this];
                    }
                });
            });
        };
        User.prototype.getCreated = function () {
            return this.getPubKey("created", true);
        };
        User.prototype.delete = function () {
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, waitDel, errObj_8;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.isDel() === false)) return [3 /*break*/, 6];
                            return [4 /*yield*/, this.getService().newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("Users").setL2("Delete").setL3("ByGuid");
                            reqObj.addReq("guid", this.getGuid());
                            waitDel = this.getPubDeleteWait();
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            _a.sent();
                            this.setDel();
                            return [4 /*yield*/, waitDel];
                        case 4:
                            _a.sent();
                            this.terminate();
                            return [3 /*break*/, 6];
                        case 5:
                            errObj_8 = _a.sent();
                            this.pubDeleteClear();
                            throw errObj_8;
                        case 6: return [2 /*return*/, this];
                    }
                });
            });
        };
        User.prototype.terminate = function (throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            this.setTerm();
            this.getService().getUsers().clearCache(this);
        };
        return User;
    }(Base));

    var Users = /** @class */ (function (_super) {
        __extends(Users, _super);
        function Users() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Users.prototype.newObj = function () {
            var rObj = new User();
            rObj.setService(this.getService());
            return rObj;
        };
        Users.prototype.getByApiObj = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (typeof this._s[apiObj.guid] === "undefined") {
                                this._s[apiObj.guid] = this.newObj();
                                this._s[apiObj.guid].construct(apiObj);
                            }
                            return [4 /*yield*/, this._s[apiObj.guid].waitInit()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/, this._s[apiObj.guid]];
                    }
                });
            });
        };
        Users.prototype.getBySession = function (cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, guids, errObj_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("Users").setL2("Get").setL3("BySession");
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            guids = _a.sent();
                            return [4 /*yield*/, this.getByGuids(guids, cbObj, cbMethod)];
                        case 4: return [2 /*return*/, _a.sent()];
                        case 5:
                            errObj_1 = _a.sent();
                            this.callException(errObj_1);
                            throw errObj_1;
                        case 6: return [2 /*return*/];
                    }
                });
            });
        };
        Users.prototype.getByGuid = function (guid, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, apiObj, errObj_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(typeof this._s[guid] !== "undefined")) return [3 /*break*/, 2];
                            return [4 /*yield*/, this._s[guid].waitInit()];
                        case 1:
                            _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](this._s[guid]);
                            }
                            return [2 /*return*/, this._s[guid]];
                        case 2: return [4 /*yield*/, this.newRequest()];
                        case 3:
                            reqObj = _a.sent();
                            reqObj.setL1("Users").setL2("Get").setL3("ByGuid");
                            reqObj.addReq("guid", guid);
                            _a.label = 4;
                        case 4:
                            _a.trys.push([4, 7, , 8]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 5:
                            apiObj = _a.sent();
                            if (typeof this._s[apiObj.guid] === "undefined") {
                                this._s[apiObj.guid] = this.newObj();
                                this._s[apiObj.guid].construct(apiObj);
                            }
                            return [4 /*yield*/, this._s[apiObj.guid].waitInit()];
                        case 6:
                            _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](this._s[apiObj.guid]);
                            }
                            return [2 /*return*/, this._s[apiObj.guid]];
                        case 7:
                            errObj_2 = _a.sent();
                            this.callException(errObj_2);
                            throw errObj_2;
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        Users.prototype.add = function (username, password, usmNsObj, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, apiObj, rObj, errObj_3;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("Users").setL2("Add").setL3("ByUserPass");
                            reqObj.addReq("username", username);
                            reqObj.addReq("password", password);
                            reqObj.addReq("usm-ns-guid", usmNsObj.getGuid());
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            apiObj = _a.sent();
                            return [4 /*yield*/, this.getByApiObj(apiObj)];
                        case 4:
                            rObj = _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](rObj);
                            }
                            return [2 /*return*/, rObj];
                        case 5:
                            errObj_3 = _a.sent();
                            this.callException(errObj_3);
                            throw errObj_3;
                        case 6: return [2 /*return*/];
                    }
                });
            });
        };
        return Users;
    }(BaseFactory));

    var Permission = /** @class */ (function (_super) {
        __extends(Permission, _super);
        function Permission() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._ns = null;
            _this._role = null;
            return _this;
        }
        Permission.prototype.construct = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.baseConstruct(apiObj)];
                        case 1:
                            _a.sent();
                            this._ns = apiObj.ns;
                            this._role = apiObj.role;
                            this.setInit();
                            return [2 /*return*/, this];
                    }
                });
            });
        };
        Permission.prototype.getNs = function () {
            return this._ns;
        };
        Permission.prototype.getRole = function () {
            return this._role;
        };
        Permission.prototype.terminate = function (throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            this.setTerm();
            this.getService().getPermissions().clearCache(this);
        };
        return Permission;
    }(Base));

    var Permissions = /** @class */ (function (_super) {
        __extends(Permissions, _super);
        function Permissions() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Permissions.prototype.newObj = function () {
            var rObj = new Permission();
            rObj.setService(this.getService());
            return rObj;
        };
        Permissions.prototype.getBySession = function (cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, guids, errObj_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("Permissions").setL2("Get").setL3("BySession");
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            guids = _a.sent();
                            return [4 /*yield*/, this.getByGuids(guids, cbObj, cbMethod)];
                        case 4: return [2 /*return*/, _a.sent()];
                        case 5:
                            errObj_1 = _a.sent();
                            this.callException(errObj_1);
                            throw errObj_1;
                        case 6: return [2 /*return*/];
                    }
                });
            });
        };
        Permissions.prototype.getByGuid = function (guid, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, apiObj, errObj_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(typeof this._s[guid] !== "undefined")) return [3 /*break*/, 2];
                            return [4 /*yield*/, this._s[guid].waitInit()];
                        case 1:
                            _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](this._s[guid]);
                            }
                            return [2 /*return*/, this._s[guid]];
                        case 2: return [4 /*yield*/, this.newRequest()];
                        case 3:
                            reqObj = _a.sent();
                            reqObj.setL1("Permissions").setL2("Get").setL3("ByGuid");
                            reqObj.addReq("guid", guid);
                            _a.label = 4;
                        case 4:
                            _a.trys.push([4, 7, , 8]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 5:
                            apiObj = _a.sent();
                            if (typeof this._s[apiObj.guid] === "undefined") {
                                this._s[apiObj.guid] = this.newObj();
                                this._s[apiObj.guid].construct(apiObj);
                            }
                            return [4 /*yield*/, this._s[apiObj.guid].waitInit()];
                        case 6:
                            _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](this._s[apiObj.guid]);
                            }
                            return [2 /*return*/, this._s[apiObj.guid]];
                        case 7:
                            errObj_2 = _a.sent();
                            throw errObj_2;
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        return Permissions;
    }(BaseFactory));

    var UserNetMap = /** @class */ (function (_super) {
        __extends(UserNetMap, _super);
        function UserNetMap() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        UserNetMap.prototype.construct = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.baseConstruct(apiObj)];
                        case 1:
                            _a.sent();
                            this.setInit();
                            return [2 /*return*/, this];
                    }
                });
            });
        };
        UserNetMap.prototype.getUser = function (cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().getUsers().getByGuid(this.getPubKey("userGuid", true), cbObj, cbMethod)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserNetMap.prototype.getNetwork = function (cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().getNetworks().getByGuid(this.getPubKey("networkGuid", true), cbObj, cbMethod)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserNetMap.prototype.getAttrs = function (cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().getUserNetMapAttrs().getByMap(this, cbObj, cbMethod)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserNetMap.prototype.addAttr = function (typeObj, value) {
            return __awaiter(this, void 0, void 0, function () {
                var attrObj, reqObj, apiObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getAttrByType(typeObj, false)];
                        case 1:
                            attrObj = _a.sent();
                            if (attrObj !== null) {
                                throw this.getMtm().newException("Cannot add attribute exists");
                            }
                            return [4 /*yield*/, this.getService().newRequest()];
                        case 2:
                            reqObj = _a.sent();
                            reqObj.setL1("UserNetMapAttrs").setL2("Add");
                            reqObj.addReq("map-guid", this.getGuid());
                            reqObj.addReq("type-guid", typeObj.getGuid());
                            reqObj.addReq("value", value);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            apiObj = _a.sent();
                            return [4 /*yield*/, this.getService().getUserNetMapAttrs().getByApiObj(apiObj)];
                        case 4: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserNetMap.prototype.getAttrByType = function (typeObj, throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            return __awaiter(this, void 0, void 0, function () {
                var attrObjs, attrObjs_1, attrObjs_1_1, attrObj, eType, e_1_1;
                var e_1, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0: return [4 /*yield*/, this.getAttrs()];
                        case 1:
                            attrObjs = _b.sent();
                            _b.label = 2;
                        case 2:
                            _b.trys.push([2, 7, 8, 9]);
                            attrObjs_1 = __values(attrObjs), attrObjs_1_1 = attrObjs_1.next();
                            _b.label = 3;
                        case 3:
                            if (!!attrObjs_1_1.done) return [3 /*break*/, 6];
                            attrObj = attrObjs_1_1.value;
                            return [4 /*yield*/, attrObj.getType()];
                        case 4:
                            eType = _b.sent();
                            if (eType.getGuid() === typeObj.getGuid()) {
                                return [2 /*return*/, attrObj];
                            }
                            _b.label = 5;
                        case 5:
                            attrObjs_1_1 = attrObjs_1.next();
                            return [3 /*break*/, 3];
                        case 6: return [3 /*break*/, 9];
                        case 7:
                            e_1_1 = _b.sent();
                            e_1 = { error: e_1_1 };
                            return [3 /*break*/, 9];
                        case 8:
                            try {
                                if (attrObjs_1_1 && !attrObjs_1_1.done && (_a = attrObjs_1.return)) _a.call(attrObjs_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                            return [7 /*endfinally*/];
                        case 9:
                            if (throwOnErr === true) {
                                throw this.getMtm().newException("Attribute type is not mapped");
                            }
                            else {
                                return [2 /*return*/, null];
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        UserNetMap.prototype.setAttr = function (typeObj, value) {
            return __awaiter(this, void 0, void 0, function () {
                var attrObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getAttrByType(typeObj, false)];
                        case 1:
                            attrObj = _a.sent();
                            if (!(attrObj === null)) return [3 /*break*/, 3];
                            return [4 /*yield*/, this.addAttr(typeObj, value)];
                        case 2:
                            attrObj = _a.sent();
                            return [3 /*break*/, 5];
                        case 3: return [4 /*yield*/, attrObj.setValue(value)];
                        case 4:
                            _a.sent();
                            _a.label = 5;
                        case 5: return [2 /*return*/, attrObj];
                    }
                });
            });
        };
        UserNetMap.prototype.clearAttr = function (attrObj) {
            return __awaiter(this, void 0, void 0, function () {
                var mapObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, attrObj.getMap()];
                        case 1:
                            mapObj = _a.sent();
                            if (mapObj.getGuid() !== this.getGuid()) {
                                throw this.getMtm().newException("Cannot delete, attribute is not mapped");
                            }
                            return [2 /*return*/, this];
                    }
                });
            });
        };
        UserNetMap.prototype.getCreated = function () {
            return this.getPubKey("created", true);
        };
        UserNetMap.prototype.delete = function () {
            return __awaiter(this, void 0, void 0, function () {
                var netObj, userObj, reqObj, waitDel, errObj_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.isDel() === false)) return [3 /*break*/, 8];
                            return [4 /*yield*/, this.getNetwork()];
                        case 1:
                            netObj = _a.sent();
                            netObj.clearUserMap(this);
                            return [4 /*yield*/, this.getUser()];
                        case 2:
                            userObj = _a.sent();
                            userObj.clearNetworkMap(this);
                            return [4 /*yield*/, this.getService().newRequest()];
                        case 3:
                            reqObj = _a.sent();
                            reqObj.setL1("UserNetMaps").setL2("Delete").setL3("ByGuid");
                            reqObj.addReq("guid", this.getGuid());
                            waitDel = this.getPubDeleteWait();
                            _a.label = 4;
                        case 4:
                            _a.trys.push([4, 7, , 8]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 5:
                            _a.sent();
                            this.setDel();
                            return [4 /*yield*/, waitDel];
                        case 6:
                            _a.sent();
                            this.terminate();
                            return [3 /*break*/, 8];
                        case 7:
                            errObj_1 = _a.sent();
                            this.pubDeleteClear();
                            throw errObj_1;
                        case 8: return [2 /*return*/, this];
                    }
                });
            });
        };
        UserNetMap.prototype.terminate = function (throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            this.setTerm();
            this.getService().getUserNetMaps().clearCache(this);
        };
        return UserNetMap;
    }(Base));

    var UserNetMaps = /** @class */ (function (_super) {
        __extends(UserNetMaps, _super);
        function UserNetMaps() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        UserNetMaps.prototype.newObj = function () {
            var rObj = new UserNetMap();
            rObj.setService(this.getService());
            return rObj;
        };
        UserNetMaps.prototype.getByApiObj = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (typeof this._s[apiObj.guid] === "undefined") {
                                this._s[apiObj.guid] = this.newObj();
                                this._s[apiObj.guid].construct(apiObj);
                            }
                            return [4 /*yield*/, this._s[apiObj.guid].waitInit()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/, this._s[apiObj.guid]];
                    }
                });
            });
        };
        UserNetMaps.prototype.getByNetwork = function (netObj, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var sTime, reqObj, guids, errObj_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            sTime = this.getMtm().get("utilities").getTime().getMicroEpoch();
                            return [4 /*yield*/, this.newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("UserNetMaps").setL2("Get").setL3("ByNetwork");
                            reqObj.addReq("guid", netObj.getGuid());
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            guids = _a.sent();
                            return [4 /*yield*/, this.getByGuids(guids, cbObj, cbMethod)];
                        case 4: return [2 /*return*/, _a.sent()];
                        case 5:
                            errObj_1 = _a.sent();
                            this.callException(errObj_1);
                            throw errObj_1;
                        case 6: return [2 /*return*/];
                    }
                });
            });
        };
        UserNetMaps.prototype.getByUser = function (userObj, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var sTime, reqObj, guids, errObj_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            sTime = this.getMtm().get("utilities").getTime().getMicroEpoch();
                            return [4 /*yield*/, this.newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("UserNetMaps").setL2("Get").setL3("ByUser");
                            reqObj.addReq("guid", userObj.getGuid());
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            guids = _a.sent();
                            return [4 /*yield*/, this.getByGuids(guids, cbObj, cbMethod)];
                        case 4: return [2 /*return*/, _a.sent()];
                        case 5:
                            errObj_2 = _a.sent();
                            this.callException(errObj_2);
                            throw errObj_2;
                        case 6: return [2 /*return*/];
                    }
                });
            });
        };
        UserNetMaps.prototype.getByGuid = function (guid, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, apiObj, rObj, errObj_3;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(typeof this._s[guid] !== "undefined")) return [3 /*break*/, 2];
                            return [4 /*yield*/, this._s[guid].waitInit()];
                        case 1:
                            _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](this._s[guid]);
                            }
                            return [2 /*return*/, this._s[guid]];
                        case 2: return [4 /*yield*/, this.newRequest()];
                        case 3:
                            reqObj = _a.sent();
                            reqObj.setL1("UserNetMaps").setL2("Get").setL3("ByGuid");
                            reqObj.addReq("guid", guid);
                            _a.label = 4;
                        case 4:
                            _a.trys.push([4, 7, , 8]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 5:
                            apiObj = _a.sent();
                            return [4 /*yield*/, this.getByApiObj(apiObj)];
                        case 6:
                            rObj = _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](rObj);
                            }
                            return [2 /*return*/, rObj];
                        case 7:
                            errObj_3 = _a.sent();
                            this.callException(errObj_3);
                            throw errObj_3;
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        UserNetMaps.prototype.add = function (userObj, netObj, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, apiObj, errObj_4;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("UserNetMaps").setL2("Add");
                            reqObj.addReq("user-guid", userObj.getGuid());
                            reqObj.addReq("net-guid", netObj.getGuid());
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            apiObj = _a.sent();
                            if (typeof this._s[apiObj.guid] === "undefined") {
                                this._s[apiObj.guid] = this.newObj();
                                this._s[apiObj.guid].construct(apiObj);
                            }
                            return [4 /*yield*/, this._s[apiObj.guid].waitInit()];
                        case 4:
                            _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](this._s[apiObj.guid]);
                            }
                            return [2 /*return*/, this._s[apiObj.guid]];
                        case 5:
                            errObj_4 = _a.sent();
                            throw errObj_4;
                        case 6: return [2 /*return*/];
                    }
                });
            });
        };
        return UserNetMaps;
    }(BaseFactory));

    var UserNetMapAttr = /** @class */ (function (_super) {
        __extends(UserNetMapAttr, _super);
        function UserNetMapAttr() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        UserNetMapAttr.prototype.construct = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.baseConstruct(apiObj)];
                        case 1:
                            _a.sent();
                            this.setInit();
                            return [2 /*return*/, this];
                    }
                });
            });
        };
        UserNetMapAttr.prototype.getMap = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().getUserNetMaps().getByGuid(this.getPubKey("mapGuid", true))];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserNetMapAttr.prototype.getType = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().getAttrTypes().getByGuid(this.getPubKey("typeGuid", true))];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        UserNetMapAttr.prototype.setValue = function (val) {
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, waitUp, errObj_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.getValue() !== val)) return [3 /*break*/, 6];
                            return [4 /*yield*/, this.getService().newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("UserNetMapAttrs").setL2("Set").setL3("Value");
                            reqObj.addReq("guid", this.getGuid());
                            reqObj.addReq("value", val);
                            waitUp = this.getPubUpdateWait();
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            _a.sent();
                            return [4 /*yield*/, waitUp];
                        case 4:
                            _a.sent();
                            return [3 /*break*/, 6];
                        case 5:
                            errObj_1 = _a.sent();
                            this.pubUpdateClear(waitUp);
                            throw errObj_1;
                        case 6: return [2 /*return*/, this];
                    }
                });
            });
        };
        UserNetMapAttr.prototype.getValue = function () {
            return this.getPubKey("value", true);
        };
        UserNetMapAttr.prototype.getCreated = function () {
            return this.getPubKey("created", true);
        };
        UserNetMapAttr.prototype.delete = function () {
            return __awaiter(this, void 0, void 0, function () {
                var mapObj, reqObj, waitDel, errObj_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.isDel() === false)) return [3 /*break*/, 7];
                            return [4 /*yield*/, this.getMap()];
                        case 1:
                            mapObj = _a.sent();
                            mapObj.clearAttr(this);
                            return [4 /*yield*/, this.getService().newRequest()];
                        case 2:
                            reqObj = _a.sent();
                            reqObj.setL1("UserNetMapAttrs").setL2("Delete").setL3("ByGuid");
                            reqObj.addReq("guid", this.getGuid());
                            waitDel = this.getPubDeleteWait();
                            _a.label = 3;
                        case 3:
                            _a.trys.push([3, 6, , 7]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 4:
                            _a.sent();
                            this.setDel();
                            return [4 /*yield*/, waitDel];
                        case 5:
                            _a.sent();
                            this.terminate();
                            return [3 /*break*/, 7];
                        case 6:
                            errObj_2 = _a.sent();
                            this.pubDeleteClear();
                            throw errObj_2;
                        case 7: return [2 /*return*/, this];
                    }
                });
            });
        };
        UserNetMapAttr.prototype.terminate = function (throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            this.setTerm();
            this.getService().getUserNetMapAttrs().clearCache(this);
        };
        return UserNetMapAttr;
    }(Base));

    var UserNetMapAttrs = /** @class */ (function (_super) {
        __extends(UserNetMapAttrs, _super);
        function UserNetMapAttrs() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        UserNetMapAttrs.prototype.newObj = function () {
            var rObj = new UserNetMapAttr();
            rObj.setService(this.getService());
            return rObj;
        };
        UserNetMapAttrs.prototype.getByApiObj = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (typeof this._s[apiObj.guid] === "undefined") {
                                this._s[apiObj.guid] = this.newObj();
                                this._s[apiObj.guid].construct(apiObj);
                            }
                            return [4 /*yield*/, this._s[apiObj.guid].waitInit()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/, this._s[apiObj.guid]];
                    }
                });
            });
        };
        UserNetMapAttrs.prototype.getByMap = function (netObj, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, guids, errObj_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("UserNetMapAttrs").setL2("Get").setL3("ByMap");
                            reqObj.addReq("guid", netObj.getGuid());
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            guids = _a.sent();
                            return [4 /*yield*/, this.getByGuids(guids, cbObj, cbMethod)];
                        case 4: return [2 /*return*/, _a.sent()];
                        case 5:
                            errObj_1 = _a.sent();
                            this.callException(errObj_1);
                            throw errObj_1;
                        case 6: return [2 /*return*/];
                    }
                });
            });
        };
        UserNetMapAttrs.prototype.getByGuid = function (guid, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, apiObj, rObj, errObj_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(typeof this._s[guid] !== "undefined")) return [3 /*break*/, 2];
                            return [4 /*yield*/, this._s[guid].waitInit()];
                        case 1:
                            _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](this._s[guid]);
                            }
                            return [2 /*return*/, this._s[guid]];
                        case 2: return [4 /*yield*/, this.newRequest()];
                        case 3:
                            reqObj = _a.sent();
                            reqObj.setL1("UserNetMapAttrs").setL2("Get").setL3("ByGuid");
                            reqObj.addReq("guid", guid);
                            _a.label = 4;
                        case 4:
                            _a.trys.push([4, 7, , 8]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 5:
                            apiObj = _a.sent();
                            return [4 /*yield*/, this.getByApiObj(apiObj)];
                        case 6:
                            rObj = _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](rObj);
                            }
                            return [2 /*return*/, rObj];
                        case 7:
                            errObj_2 = _a.sent();
                            throw errObj_2;
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        return UserNetMapAttrs;
    }(BaseFactory));

    var AttrType = /** @class */ (function (_super) {
        __extends(AttrType, _super);
        function AttrType() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AttrType.prototype.construct = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.baseConstruct(apiObj)];
                        case 1:
                            _a.sent();
                            this.setInit();
                            return [2 /*return*/, this];
                    }
                });
            });
        };
        AttrType.prototype.getLabel = function () {
            return this.getPubKey("label", true);
        };
        AttrType.prototype.getDisplayName = function () {
            return this.getPubKey("displayName", true);
        };
        AttrType.prototype.getName = function () {
            return this.getPubKey("attrName", true);
        };
        AttrType.prototype.getOperator = function () {
            return this.getPubKey("operator", true);
        };
        AttrType.prototype.getCreated = function () {
            return this.getPubKey("created", true);
        };
        AttrType.prototype.terminate = function (throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            this.setTerm();
            this.getService().getAttrTypes().clearCache(this);
        };
        return AttrType;
    }(Base));

    var AttrTypes = /** @class */ (function (_super) {
        __extends(AttrTypes, _super);
        function AttrTypes() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AttrTypes.prototype.newObj = function () {
            var rObj = new AttrType();
            rObj.setService(this.getService());
            return rObj;
        };
        AttrTypes.prototype.getByApiObj = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (typeof this._s[apiObj.guid] === "undefined") {
                                this._s[apiObj.guid] = this.newObj();
                                this._s[apiObj.guid].construct(apiObj);
                            }
                            return [4 /*yield*/, this._s[apiObj.guid].waitInit()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/, this._s[apiObj.guid]];
                    }
                });
            });
        };
        AttrTypes.prototype.getAll = function (cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, guids, errObj_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("AttrTypes").setL2("Get").setL3("All");
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            guids = _a.sent();
                            return [4 /*yield*/, this.getByGuids(guids, cbObj, cbMethod)];
                        case 4: return [2 /*return*/, _a.sent()];
                        case 5:
                            errObj_1 = _a.sent();
                            this.callException(errObj_1);
                            throw errObj_1;
                        case 6: return [2 /*return*/];
                    }
                });
            });
        };
        AttrTypes.prototype.getByGuid = function (guid, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, apiObj, rObj, errObj_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(typeof this._s[guid] !== "undefined")) return [3 /*break*/, 2];
                            return [4 /*yield*/, this._s[guid].waitInit()];
                        case 1:
                            _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](this._s[guid]);
                            }
                            return [2 /*return*/, this._s[guid]];
                        case 2: return [4 /*yield*/, this.newRequest()];
                        case 3:
                            reqObj = _a.sent();
                            reqObj.setL1("AttrTypes").setL2("Get").setL3("ByGuid");
                            reqObj.addReq("guid", guid);
                            _a.label = 4;
                        case 4:
                            _a.trys.push([4, 7, , 8]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 5:
                            apiObj = _a.sent();
                            return [4 /*yield*/, this.getByApiObj(apiObj)];
                        case 6:
                            rObj = _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](rObj);
                            }
                            return [2 /*return*/, rObj];
                        case 7:
                            errObj_2 = _a.sent();
                            throw errObj_2;
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        return AttrTypes;
    }(BaseFactory));

    var Session = /** @class */ (function (_super) {
        __extends(Session, _super);
        function Session() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._cObj = null;
            return _this;
        }
        Session.prototype.construct = function (cObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    this._cObj = cObj;
                    this.setInit();
                    return [2 /*return*/, this];
                });
            });
        };
        Session.prototype.getNetworks = function (cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().getNetworks().getBySession(cbObj, cbMethod)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        Session.prototype.getUsers = function (cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().getUsers().getBySession(cbObj, cbMethod)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        Session.prototype.getPermissions = function (cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().getPermissions().getBySession(cbObj, cbMethod)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        return Session;
    }(i1.DcSccBaseValidators));

    var DcRasApi = /** @class */ (function () {
        function DcRasApi(_dcScc, _dcEasApi) {
            this._dcScc = _dcScc;
            this._dcEasApi = _dcEasApi;
            this._connFact = null;
            this._sessObj = null;
            this._netFact = null;
            this._nasFact = null;
            this._uFact = null;
            this._permFact = null;
            this._unmFact = null;
            this._unmaFact = null;
            this._atFact = null;
            this._ddsClient = null;
            this._dcScc.getMtm().set("DcRasApi", this);
        }
        DcRasApi.prototype.getDcScc = function () {
            return this._dcScc;
        };
        DcRasApi.prototype.getMtm = function () {
            return this.getDcScc().getMtm();
        };
        DcRasApi.prototype.getLogging = function () {
            return this.getDcScc().getLogging();
        };
        DcRasApi.prototype.getSession = function () {
            return __awaiter(this, void 0, void 0, function () {
                var _a, _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            if (!(this._sessObj === null)) return [3 /*break*/, 2];
                            this._sessObj = new Session();
                            this._sessObj.setService(this);
                            _b = (_a = this._sessObj).construct;
                            return [4 /*yield*/, this.getConnection().getClient()];
                        case 1:
                            _b.apply(_a, [_c.sent()]);
                            this._sessObj.setExceptionCb(this.getLogging(), "exception");
                            _c.label = 2;
                        case 2: return [2 /*return*/, this._sessObj.waitInit()];
                    }
                });
            });
        };
        DcRasApi.prototype.getConnection = function () {
            if (this._connFact === null) {
                this._connFact = new Connection();
                this._connFact.setService(this);
                this._connFact.setExceptionCb(this.getLogging(), "exception");
            }
            return this._connFact;
        };
        DcRasApi.prototype.getNetworks = function () {
            if (this._netFact === null) {
                this._netFact = new Networks();
                this._netFact.setService(this);
                this._netFact.setExceptionCb(this.getLogging(), "exception");
            }
            return this._netFact;
        };
        DcRasApi.prototype.getNasDevices = function () {
            if (this._nasFact === null) {
                this._nasFact = new NasDevices();
                this._nasFact.setService(this);
                this._nasFact.setExceptionCb(this.getLogging(), "exception");
            }
            return this._nasFact;
        };
        DcRasApi.prototype.getUserNetMaps = function () {
            if (this._unmFact === null) {
                this._unmFact = new UserNetMaps();
                this._unmFact.setService(this);
                this._unmFact.setExceptionCb(this.getLogging(), "exception");
            }
            return this._unmFact;
        };
        DcRasApi.prototype.getUserNetMapAttrs = function () {
            if (this._unmaFact === null) {
                this._unmaFact = new UserNetMapAttrs();
                this._unmaFact.setService(this);
                this._unmaFact.setExceptionCb(this.getLogging(), "exception");
            }
            return this._unmaFact;
        };
        DcRasApi.prototype.getAttrTypes = function () {
            if (this._atFact === null) {
                this._atFact = new AttrTypes();
                this._atFact.setService(this);
                this._atFact.setExceptionCb(this.getLogging(), "exception");
            }
            return this._atFact;
        };
        DcRasApi.prototype.getUsers = function () {
            if (this._uFact === null) {
                this._uFact = new Users();
                this._uFact.setService(this);
                this._uFact.setExceptionCb(this.getLogging(), "exception");
            }
            return this._uFact;
        };
        DcRasApi.prototype.getPermissions = function () {
            if (this._permFact === null) {
                this._permFact = new Permissions();
                this._permFact.setService(this);
                this._permFact.setExceptionCb(this.getLogging(), "exception");
            }
            return this._permFact;
        };
        DcRasApi.prototype.getDdsClient = function () {
            return __awaiter(this, void 0, void 0, function () {
                var ddsHost, ddsPort, ddsSsl;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this._ddsClient === null)) return [3 /*break*/, 2];
                            ddsHost = "dc-wss-nlb.datacamo.net";
                            ddsPort = 28106;
                            ddsSsl = true;
                            this._ddsClient = this.getMtm().get("DcDdsApi").getClients().getV1(ddsHost, ddsPort, ddsSsl);
                            return [4 /*yield*/, this._ddsClient.initialize()];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2: return [2 /*return*/, this._ddsClient];
                    }
                });
            });
        };
        DcRasApi.prototype.newRequest = function () {
            return __awaiter(this, void 0, void 0, function () {
                var cObj, cObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getConnection().getClient()];
                        case 1:
                            cObj = _a.sent();
                            return [4 /*yield*/, cObj.isAuth()];
                        case 2:
                            cObj = _a.sent();
                            return [2 /*return*/, cObj.newMessage()];
                    }
                });
            });
        };
        return DcRasApi;
    }());
    DcRasApi.ɵprov = i0.ɵɵdefineInjectable({ factory: function DcRasApi_Factory() { return new DcRasApi(i0.ɵɵinject(i1.DcScc), i0.ɵɵinject(i2.DcEasApi)); }, token: DcRasApi, providedIn: "root" });
    DcRasApi.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    DcRasApi.ctorParameters = function () { return [
        { type: i1.DcScc },
        { type: i2.DcEasApi }
    ]; };

    /*
     * Public API Surface of dc-ras-api
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.DcRasApi = DcRasApi;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=dc-ras-api.umd.js.map
